(function () {
    global.dashModule
        .controller('shopCtrl', ['$scope', shopController])
        .directive('shop', [shopDirective]);

    function shopDirective() {
        return {
            restrict: 'E',
            templateUrl: 'shop/html/shopTemplate'
        };
    }

    function shopController($scope) {
        $scope.isSubmoduleVisible = isSubmoduleVisible;
        $scope.setSubModule = setSubModule;
        $scope.subModule = global.getParameterByName('subModule') || 'shop';
        addUrlListener();

        function addUrlListener() {
            window.addEventListener('popstate', function (e) {
                $scope.$evalAsync($scope => {
                    $scope.subModule = e.state ? e.state.subModule : 'shop';
                });
            }, false);
        }

        function setSubModule($event) {
            $scope.subModule = $event.currentTarget.attributes.subModule.value;
            history.pushState({
                subModule: $scope.subModule
            }, null, '?subModule=' + $scope.subModule);
        }

        function isSubmoduleVisible(subModule) {
            return subModule === $scope.subModule;
        }
    }
})();
